* Note:  When we are seeking a record, we want to trim all spaces except the ones entered by the user.
* 		 To do this we force the space to be another character before we trim up the field, and then 
* 		 we change them back to spaces after we trim (but before we search).  This is what
*		 "d_invisichar" is used for.
#DEFINE d_invisichar 160

define class PPMfrmSrch as form
  scalemode=0
  windowtype=1 && modal
  caption="Search"
  backcolor=rgb(128,128,128)
  closable=.f.
  r_nrecno=0
  r_cretval=""
  r_caction=""
  add object lblSearch as Label with ;
    caption="Search for:",autosize=.T.,backstyle=0
  add object txtSrchstring as PPMtxtsrchstring 
  add object grdSrch as PPMgrdSrch with top=2
  add object cmdSelect as PPMcmdsrchselect
  add object cmdCancel as PPMcmdsrchcancel
  procedure destroy
    release g_nrecno
  endproc 
  procedure init
    public g_nrecno
    g_nrecno=recno()
    local l_oldscreenscale
    this.scalemode=0
    this.minheight=12
    this.minwidth=30
    this.scalemode=3
    l_oldscreenscale=_screen.scalemode
    _screen.scalemode=3
    this.width=_screen.width*.67
    this.height=_screen.height*.60
    this.autocenter=.t.
    this.txtsrchstring.left=this.lblsearch.width+2
    this.minwidth=this.cmdSelect.width+this.cmdCancel.width+8
    this.resize()
    this.scalemode=0
    _screen.scalemode=l_oldscreenscale
  endproc && init
  procedure resize
    this.scalemode=3
    this.grdsrch.width=this.width
    this.txtsrchstring.width=this.width-this.txtsrchstring.left
    this.scalemode=0
    this.grdsrch.height=this.height-4
    this.m_buttonresize()
  endproc && resize
  
  procedure m_buttonresize
    this.cmdSelect.top=this.height-this.cmdSelect.height-.2
    this.cmdCancel.top=this.height-this.cmdCancel.height-.2
    this.scalemode=3
    l_buttspace=this.width/2
    this.cmdSelect.left=l_buttspace/2-this.cmdSelect.width/2
    this.cmdCancel.left=l_buttspace*1.5-this.cmdCancel.width/2
  endproc && m_buttonresize
  
  procedure m_newcol
    parameters p_controlsource,p_order,p_header,p_width
    this.grdsrch.m_newcol(p_controlsource,p_order,p_header,p_width)
    this.grdsrch.readonly=.T.
  endproc && m_newcol
  
  procedure m_retval
    parameters p_string,p_recno,p_action
    p_string=this.r_cretval
    p_recno=this.r_nrecno
    p_action=this.r_caction
    return this.r_cretval
  endproc && m_retval
enddefine && PPMfrmsrch

define class PPMfrmSrchAdd as PPMfrmSrch
  add object cmdAdd as PPMcmdsrchadd
  procedure init
    PPMfrmsrch::init()
    this.minwidth=this.cmdAdd.width+this.cmdSelect.width+this.cmdCancel.width+8
  endproc && init
  procedure m_buttonresize
    this.cmdSelect.top=this.height-this.cmdSelect.height-.2
    this.cmdCancel.top=this.height-this.cmdCancel.height-.2
    this.cmdAdd.top=this.height-this.cmdAdd.height-.2
    this.scalemode=3
    l_buttspace=this.width/3
    this.cmdAdd.left=l_buttspace/2-this.cmdAdd.width/2
    this.cmdSelect.left=l_buttspace*1.5-this.cmdSelect.width/2
    this.cmdCancel.left=l_buttspace*2.5-this.cmdCancel.width/2
  endproc && m_buttonresize
enddefine && PPMfrmsrchadd


define class PPMgrdSrch as grid
  r_nrecno=0
  readonly=.T.
  mousepointer=1
  dynamicbackcolor=iif(recno()/3=int(recno()/3),rgb(0,0,255),rgb(255,0,0))
  columncount=0
  procedure m_newcol
    parameters p_controlsource,p_order,p_header,p_width
    local l_colname,l_wantbold
    l_colname="grc"+ltrim(str(this.columncount+1))
    this.addobject(l_colname,"PPMgrcsrch")
    l_wantbold=this.columncount=1
    if this.columncount=1
      set order to (p_order) 
    endif
    with this.&l_colname
      .currentcontrol="mytext"
      .mytext.r_order=p_order
      .controlsource=p_controlsource
      .header1.caption=p_header
      .header1.fontbold=l_wantbold
      .width=iif(type('p_width')="N",p_width,len(eval(p_controlsource)))
      .visible=.T.
    endwith
  endproc && init
enddefine && grdsrch

define class PPMgrcsrch as column
  dynamicbackcolor="iif(recno()=g_nrecno,rgb(0,255,0),rgb(255,255,255))"
  add object mytext as PPMtxtgrdsrch
  add object header1 as header
  proc init
    this.header1.fontbold=.F.
  endproc
enddefine

define class PPMtxtgrdsrch as textbox
  style=0
  mousepointer=1
  readonly=.T.
  r_oldbell=""
  r_order=""
  backcolor=rgb(0,255,0)
  selectedbackcolor=rgb(0,255,0)
  selectedforecolor=rgb(0,0,0)
  specialeffect=1
  borderstyle=0
  procedure dblclick
    thisform.cmdSelect.click
  endproc && doubleclick
  procedure gotfocus
    if (!empty(this.r_order)) and order()<>upper(this.r_order)
      l_recno=recno()
      set order to (this.r_order)
      thisform.refresh
      goto (l_recno)
      this.parent.header1.fontbold=.T.    
    endif
    if g_nrecno<>recno()
      g_nrecno=recno()
      thisform.refresh
    endif
  endproc && gotfocus
  procedure keypress
    parameters p_key,p_ctrl
    local l_srchstring
    l_srchstring=alltrim(thisform.txtSrchstring.value)
    DO CASE
      case p_key=32 && space bar
        thisform.txtsrchstring.value=l_srchstring+chr(d_invisichar)
      CASE BETWEEN(p_key,33,126) && Normal Keys
        thisform.txtSrchstring.value=l_srchstring+;
          UPPER(CHR(p_key))
      CASE (p_key=8) and empty(l_srchstring)  && Backspace
        ?? chr(7)
      case (p_key=8) && backspace
        thisform.txtSrchstring.value=left(l_srchstring,;
          len(l_srchstring)-1)
      CASE (p_key=127) && Ctrl+Backspace
        thisform.txtSrchstring.value=""
      CASE (p_key=1) && Home
        GO TOP 
      CASE (p_key=6) && End
        GO BOTTOM 
      CASE (p_key=27) && Esc
        thisform.cmdcancel.click()
      CASE (p_key=13) && Enter
        thisform.cmdselect.click()
    ENDCASE
  endproc && keypress
  procedure lostfocus
    this.parent.header1.fontbold=.F.
  endproc && lostfocus
enddefine && PPMtxtgrdsrch

define class PPMtxtsrchstring as textbox  
  format="!"
  procedure interactivechange
		if !chrsaw(.5)
	    if not seek(chrtran(alltrim(this.value),;
  	    chr(d_invisichar)," "))
    	  if between(recno(0),1,reccount())
      	  goto recno(0)
	      else
  	      go bottom
    	  endif
	    endif
  	  l_nrecno=recno()
    	g_nrecno=l_nrecno
	    l_nselstart=this.selstart
  	  thisform.refresh
    	this.selstart=l_nselstart
    endif
  endproc  
  procedure programmaticchange
    this.interactivechange()
  endproc
enddefine && PPMtxtsrchstring

define class PPMcmdsrch as commandbutton
  height=1.5
  procedure click
    thisform.r_cretval=alltrim(thisform.txtsrchstring.value)
    thisform.r_cretval=chrtran(thisform.r_cretval,chr(d_invisichar)," ")
    thisform.r_nrecno=recno()
    thisform.r_caction=chrtran(this.caption,"\<","")
    thisform.hide
  endproc
enddefine

define class PPMcmdsrchselect as PPMcmdsrch
  caption="\<Select"
  default=.T.
enddefine && PPMcmdsrchselect

define class PPMcmdsrchcancel as PPMcmdsrch
  caption="\<Cancel"
  cancel=.T.
enddefine && PPMcmdsrchcancel

define class PPMcmdsrchadd as PPMcmdsrch
  caption="\<Add"
enddefine && PPMcmdsrchadd

